<script lang="ts">
	export let variants = [];
	export let props = {};
	export let variantsPrefix: string = '';
	export let component: any;
	export let noSlot: boolean = false;
	export let componentSelector: string;
	// svelte-ignore unused-export-let
	export let enums = {}; // used by eval

	// Makes all possible combinations of a nested array
	function lazyCartesianProduct(sets, f, context) {
		if (!context) context = this;
		var p = [],
			max = sets.length - 1,
			lens = [];
		for (var i = sets.length; i--; ) lens[i] = sets[i].length;
		function dive(d) {
			var a = sets[d],
				len = lens[d];
			if (d == max) for (var i = 0; i < len; ++i) (p[d] = a[i]), f.apply(context, p);
			else for (var i = 0; i < len; ++i) (p[d] = a[i]), dive(d + 1);
			p.pop();
		}
		dive(0);
	}

	const combosObject = {};

	lazyCartesianProduct(
		variants,
		function (...combos) {
			const currentCombo = {};
			let currentComboName = '';

			combos.forEach((combo) => {
				const comboSplit = combo.split('.');
				const key = comboSplit[0].substring(variantsPrefix.length).toLowerCase();
				currentCombo[key] = enums[comboSplit[0]][comboSplit[1]];
				currentComboName += comboSplit[1] + '-';
			});

			combosObject[currentComboName.slice(0, -1)] = currentCombo;
		},
		null
	);

	const htmlCodes = {};

	for (const comboKey in combosObject) {
		if (Object.prototype.hasOwnProperty.call(combosObject, comboKey)) {
			const combo = combosObject[comboKey];

			let htmlCode = '<' + componentSelector;
			for (const attribute in combo) {
				if (Object.prototype.hasOwnProperty.call(combo, attribute)) {
					const value = combo[attribute];
					htmlCode += ' ' + attribute + '="' + value + '"' + '\n';
				}
			}

			for (const attribute in props) {
				if (Object.prototype.hasOwnProperty.call(props, attribute)) {
					const value = props[attribute];
					htmlCode += ' ' + attribute + '="' + value + '"' + '\n';
				}
			}

			htmlCode += '>\n <slot /> \n</' + componentSelector + '>';
			htmlCodes[comboKey] = htmlCode;
		}
	}
</script>

<ul>
	{#each Object.keys(combosObject) as comboKey, i}
		<li>
			{#if !noSlot}
				<svelte:component this={component} {...combosObject[comboKey]} {...props}>
					<slot />
				</svelte:component>
			{:else}
				<svelte:component this={component} {...combosObject[comboKey]} {...props} />
			{/if}
			<details>
				<summary>Code</summary>
				<textarea cols="24" rows="6" readonly>{htmlCodes[comboKey]}</textarea>
			</details>
		</li>
	{/each}
</ul>

<style lang="scss">
	ul {
		display: grid;
		grid-template-columns: 1fr;
		gap: 1em;
		margin: 0;
		padding: 0;
		list-style: none;

		@media (min-width: 760px) {
			grid-template-columns: 1fr 1fr;
			gap: 2em;
		}
	}

	details {
		position: relative;

		summary {
			cursor: pointer;

			&:hover,
			&:focus {
				opacity: 0.75;
			}
		}
		textarea {
			z-index: 1;
			position: absolute;
			top: 100%;
			left: 0;
			display: block;
			margin: 0 auto;
			resize: vertical;
			width: 100%;
			color: inherit;
			padding: 0.5em;
			border-radius: 4px;
			border: 2px solid var(--color-card-glass-border);
			background-color: var(--color-card-glass-bg);
			font: inherit;
			font-family: 'Courier New', Courier, monospace;
			-webkit-backdrop-filter: blur(1em);
			backdrop-filter: blur(1em);

			@supports not (-webkit-backdrop-filter: blur(1em)) {
				background-color: var(--color-card-bg);
			}

			@supports (backdrop-filter: blur(1em)) {
				background-color: var(--color-card-glass-bg);
			}

			@media (min-width: 760px) {
				left: -50%;
				transform: translateX(50%);
			}
		}
	}
</style>
